function LoginAssistant() {
	/* this is the creator function for your scene assistant object. It will be passed all the 
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
}

LoginAssistant.prototype.setup = function() {
	/* this function is for setup tasks that have to happen when the scene is first created */
		
	/* use Mojo.View.render to render view templates and add them to the scene, if needed. */
	
	/* setup widgets here */
	
	var attributes = {
			hintText: 'enter password',
			textFieldName:	'passwordField',
			modelProperty: 'original',
			label: 'password'
	};
		this.passModel = {
			'original' : ''
	};

	this.controller.setupWidget('passwordField', attributes, this.passModel);
		
	var textBoxAttrs = {
			hintText: 'Host Address',
			textFieldName:	'name', 
			modelProperty:		'original', 
			multiline:		false,
			disabledProperty: 'disabled',
			focus: 			true, 
			modifierState: 	Mojo.Widget.capsLock,
			//autoResize: 	automatically grow or shrink the textbox horizontally,
			//autoResizeMax:	how large horizontally it can get
			//enterSubmits:	when used in conjunction with multline, if this is set, then enter will submit rather than newline
			limitResize: 	false, 
			holdToEnable:  false, 
			focusMode:		Mojo.Widget.focusSelectMode,
			changeOnKeyPress: true,
			textReplacement: false,
			maxLength: 100,
			requiresEnterKey: false
	};
	this.txtModel = {
		'original' : '',
		disabled: false
	};
	
	this.refreshAttributes = 
	{
			label:	'Refresh Rate (Seconds)',
			min: 0,
			max: 10,
			modelProperty:	'value'
	};
	this.refrehModel = 
	{
			value : 1
	}	

	this.selectorChanged = this.selectorChanged.bindAsEventListener(this);
	Mojo.Event.listen(this.controller.get('qualitySelector'), Mojo.Event.propertyChange, this.selectorChanged);
	
	//setup the choice arrays
	this.setupChoices();
	
	this.controller.setupWidget('qualitySelector', {label: $L('Image Compression'), choices: this.qualities, modelProperty:'selectedQuality'}, this.selectorsModel);
		
	this.controller.setupWidget('refreshRate', this.refreshAttributes, this.refrehModel);
	
	/* add event handlers to listen to events from widgets */
	this.controller.setupWidget('textField', textBoxAttrs, this.txtModel);
	
	this.controller.setupWidget('Login', {}, {buttonLabel: 'Login'});
	
	this.login = this.login.bind(this)
	
	Mojo.Event.listen(this.controller.get('Login'),Mojo.Event.tap, this.login);
}

//displays the current state of various selectors
LoginAssistant.prototype.selectorChanged = function(event) {
		
}

//function declares & initializes our choice arrays
LoginAssistant.prototype.setupChoices = function(){
	
	this.selectorsModel = {selectedQuality: '64Color'}
	
	// Options for list selector choices:
	this.qualities = [                  
			{label:$L('Full Color'), value:"fullColor", secondaryIcon:'status-available'}, 
			{label:$L('256 Colors'), value:"256Color" , secondaryIcon:'status-available'}, 
			{label:$L('64 Colors'), value:"64Color" , secondaryIcon:'status-available'},
			{label:$L('16 Colors'), value:"16Color" , secondaryIcon:'status-available'},
			{label:$L('JPEG (Lossy)'), value:"jpeg", secondaryIcon:'status-available'} ]
}

LoginAssistant.prototype.login = function ()
{	 
	var req = new XMLHttpRequest();
	
	var hostURL = this.controller.get('textField').mojo.getValue();
	
	req.open("POST", hostURL, true);
	
	// create the post data
	var data = "command=login&param1=" + this.controller.get('passwordField').mojo.getValue() + "&r=" + this.refrehModel.value + "&ic=" + this.selectorsModel.selectedQuality;
	//Mojo.Controller.getAppController().showBanner("sent", {source: 'notification'}); 
	req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	//req.setRequestHeader("Content-length", data.length);
	
	req.onreadystatechange = function () 
	{		  		
		   if (req.readyState == 4) 
		   {
			   //Mojo.Controller.getAppController().showBanner(req.responseText, {source: 'notification'});
			   handleResponse(req.responseText, hostURL);			   
		   };
	}
	
	//console.log(data);
	req.send(data); 
     
	//Mojo.Controller.getAppController().showBanner("sent", {source: 'notification'});
}

function handleResponse(response, hostURL)
{
	if(response != "Invalid Password")
	{
		//Mojo.Controller.getAppController().showBanner(response, {source: 'notification'});
		
		Mojo.Controller.stageController.pushScene("Main", response, hostURL);
	}
	else	
	{
		Mojo.Controller.getAppController().showBanner(response, {source: 'notification'});
	}
}
LoginAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
	Mojo.Controller.getAppController().showBanner("Please Donate, Thanks!", {source: 'notification'});
}


LoginAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
}

LoginAssistant.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
	
	 Mojo.Event.stopListening(this.controller.get('qualitySelector'), Mojo.Event.propertyChange, this.selectorChanged);
}
